before_script:
  - chmod +x mvnw

stages:
  - install
  - tests
  - build

image: openjdk:8-jdk-slim
cache:
  paths:
    - .m2/repository/
  key: "$CI_PIPELINE_ID"
  policy: pull

variables:
  MAVEN_OPTS: "-Dhttps.protocols=TLSv1.2 -Dmaven.color=false -Dmaven.repo.local=.m2/repository -Dorg.slf4j.simpleLogger.log.org.apache.maven.cli.transfer.Slf4jMavenTransferListener=WARN -Dorg.slf4j.simpleLogger.showDateTime=true -Djava.awt.headless=true -Dmaven.repo.local=.m2/repository"
  MAVEN_CLI_OPTS: "--batch-mode --errors --fail-at-end --show-version -DinstallAtEnd=true -DdeployAtEnd=true"

dependencies:
  stage: install
  cache:
    paths:
    - .m2/repository/
    key: "$CI_PIPELINE_ID"
    policy: push
  script:
    - ./mvnw $MAVEN_CLI_OPTS dependency:resolve

build:
  stage: build
  script: ./mvnw $MAVEN_CLI_OPTS clean compile jib:build

unit:
  stage: tests
  variables:
    SCOPE: $CI_JOB_NAME
  before_script:
    - env
  script: ./mvnw $MAVEN_CLI_OPTS test jacoco:report
  artifacts:
    paths:
      - target/site/jacoco/*
    reports:
      junit:
        - target/surefire-reports/TEST-*.xml
        - target/failsafe-reports/TEST-*.xml
    expire_in: 1 week
    when: on_success

e2e:
  stage: tests
  variables:
    SCOPE: $CI_JOB_NAME
  before_script:
    - env
  script: ./mvnw $MAVEN_CLI_OPTS test
